/*********************************************************************
 Author:  Ruriko Yoshida
 Data:    June 7th, 2004
 Update:  July 24th, 2005
 Program: This code defines a class which stores a list of all m weights.

***********************************************************************/

#ifndef TAXA__H
#define TAXA__H


#include <fstream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

using namespace std;

class Taxa{
 public:
  double wt;
  int * array;
  double * edgeWts;

  Taxa(int m){
    array = new int[m];
    edgeWts = new double[m];
    wt = 0.0;
  }
  
  Taxa(){
    wt = 0.0;
  }
  void Assgn(int m){
    array = new int[m];
    edgeWts = new double[m];
  }
  ~Taxa(){
    delete [] array;
    delete [] edgeWts;
  }

};

void swap(int & x, int & y);

void bubblesort(int n, int * array);

#endif
