/*********************************************************************
 Author:  Ruriko Yoshida
 Data:    November 25th, 2003
 Update:  April 22nd, 2004
 Program: This code defines TreeNodes for the binary tree.

***********************************************************************/
#ifndef TREENODE__H
#define TREENODE__H

#include <iostream.h>
#include <fstream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

using namespace std;

class TreeNode{
 public:
  double wt;
  int name;
  char* RealName;
  int hight;
  int flag;
  int num;
  TreeNode * parent;
  TreeNode * left;
  TreeNode * right;
  TreeNode * middle;
  TreeNode * g_val;
  TreeNode * p_val;
  TreeNode * q_val;
  TreeNode * x_val;
  TreeNode(){
    wt = -10000;
    name = -1;
    hight = 1;
    flag = 0;
    num = 0;
    parent = NULL;
    left = NULL;
    right = NULL;
    middle = NULL;
    p_val = NULL;
    q_val = NULL;
    g_val = NULL;
    x_val = NULL;
  }

  void Allocate(char* a){
    RealName = new char[strlen(a) + 1];
    strcpy(RealName, a);
  }
  void printNode(){
    if(name != -1)
      cout << name << ": ";
    else{
      if(wt != -10000) cout << "y: ";
      else {cout << "r: ";}
    }
    if(wt != -10000)
    cout << wt << " " << num << endl;
    else cout << endl;
  }
};

#endif
